{PcxtoRAw}
type
    ColorValue  = record Rvalue,Gvalue,Bvalue: byte; end;
    PaletteType = array [0..255] of ColorValue;
var p:paletteType;
    pcx:pointer;
    as,ao:Word;
    fil:file;
Const
     Crtadress              : word   = $3d4;
     Inputstatus            : word   = $3DA;
     Graph_Index            : word   = $3CE;


Procedure LoadPcxbuf(Fname:String;var as,ao:word;var q:palettetype);
Const
  DataBuffer = $2800;                                      { 10K Data Buffer Area}
type
    Pal        = array[0..767] of byte;

Var
  ScrOff,Buf,HowMany : LongInt;                            { Decompress Variables }
  PcxBuffer : Array[1..DataBuffer] Of Byte;                { Declare DataBuffer Size }
  RGBs : Array[0..767] of Byte;                            { Temp Colour Palette Storage }
  DataByte : Byte;                                         { Current Byte Being Processed }
  NumRead : Word;                                          { Temporary Variable }
  F : File;                                                { File Variable }
  p:Pal;

Procedure MoveIt(SSeg,SOfs,TSeg,TOfs,L: Word);
Begin
 Asm
  PUSHF
  cld
  push  ds
  mov   si,SOfs
  mov   di,TOfs
  mov   cx,l
  mov   es,[tseg]
  mov   ds,[sseg]
  shr   cx,1
  rep  movsw
  jnb  @even
  movsb
@even:
  pop ds
  POPF
 End;
End;


procedure Fillarea(as,ao,l,color:word);assembler;
Asm
    push es
    mov  es,[as]               { Point es to screen segment }
    mov  di,ao
    mov  ax,color
    mov  cx,l
    PUSHF
    cld
    rep  stosb               { use a fast 8088 instruction to store al }
@even:
    POPF
    pop  es
end;


Procedure ShiftPcxPalette(var p:pal);
var loop:integer;
Begin
  For Loop:=0 To 767 Do p[Loop]:=RGBs[Loop] SHR 2;      { Helps Set Colours Correctly }
End;

Procedure FillBuffer;
Begin
  If (Buf> DataBuffer) Then                             { Refresh Buffer ? }
  Begin
    Buf:=1;
    BlockRead(F,PcxBuffer,SizeOf(PcxBuffer),NumRead);    { Read Chunk Of Data From .Pcx File }
  End;
  DataByte:=PcxBuffer[Buf];                             { Take A Byte From The Buffer }
  Inc(Buf,1);
End;

Begin
  Assign(F,FName);
  Reset(F,1);                                              { Use records with length 1}
  Seek(F,128);                                             { Ignore .Pcx Header }
  HowMany:=0;  ScrOff:=0;
  Buf:=DataBuffer + 1;
  While (ScrOff < $fa00) Do
  Begin
    FillBuffer;
    HowMany:=1;                                            { Contiguous Bytes Set To 1 }
    If (DataByte AND $C0) = $C0 Then                       { If DataByte's Top 2 Bits Are 1 }
    Begin
      HowMany:=DataByte AND $3F;                           { It's An RLE (Run Length Encoded) Byte }
      FillBuffer;                                          { Refresh Buffer If Need Be }
    End;
    Fillarea(AS,AO+ScrOff,HowMany,DataByte);          { Write DataByte(s) Directly To Video Memory }
    Inc(ScrOff,HowMany);                                   { Increase Video Memory OffSet }
  End;
  Seek(F,FileSize(F) - 768);
  BlockRead(F,RGBs,SizeOf(RGBs),NumRead);
  ShiftPcxPalette(p);
  Close(F);
  Moveit(seg(p),ofs(p),seg(q),ofs(q),768)
End;

PROCEDURE WAITVERT;assembler;
asm
    mov    dx,INPUTSTATUS
@WaitDE:
    in     al,dx
    test   al,01h
    jz    @WaitDE
END;
begin
writeln('pcxtoraw fil.pcx fil.raw fil.pal');
if paramstr(1)='' then exit;
getmem(pcx, 64000);
as:=seg(pcx^);
ao:=Ofs(pcx^);
LoadPcxBuf(Paramstr(1),as, ao, p);
Assign(fil,Paramstr(2));
rewrite(fil,1);
blockwrite(fil,mem[as:ao],64000);
close(fil);

Assign(fil,Paramstr(3));
rewrite(fil,1);
blockwrite(fil, p,256*3);
close(fil);

end.